/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the RedeemCouponWebhook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RedeemCouponWebhook{}

// RedeemCouponWebhook struct for RedeemCouponWebhook
type RedeemCouponWebhook struct {
	TransactionId string `json:"transaction_id"`
	ConversationId string `json:"conversation_id"`
	ContactId string `json:"contact_id"`
	Code string `json:"code"`
	Attributes map[string]interface{} `json:"attributes,omitempty"`
	ChannelId string `json:"channel_id"`
	Redeemed bool `json:"redeemed"`
	ErrorMessage *string `json:"error_message,omitempty"`
	TotalAmount string `json:"total_amount"`
}

// NewRedeemCouponWebhook instantiates a new RedeemCouponWebhook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRedeemCouponWebhook(transactionId string, conversationId string, contactId string, code string, channelId string, redeemed bool, totalAmount string) *RedeemCouponWebhook {
	this := RedeemCouponWebhook{}
	this.TransactionId = transactionId
	this.ConversationId = conversationId
	this.ContactId = contactId
	this.Code = code
	this.ChannelId = channelId
	this.Redeemed = redeemed
	this.TotalAmount = totalAmount
	return &this
}

// NewRedeemCouponWebhookWithDefaults instantiates a new RedeemCouponWebhook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRedeemCouponWebhookWithDefaults() *RedeemCouponWebhook {
	this := RedeemCouponWebhook{}
	return &this
}

// GetTransactionId returns the TransactionId field value
func (o *RedeemCouponWebhook) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *RedeemCouponWebhook) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetConversationId returns the ConversationId field value
func (o *RedeemCouponWebhook) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *RedeemCouponWebhook) SetConversationId(v string) {
	o.ConversationId = v
}

// GetContactId returns the ContactId field value
func (o *RedeemCouponWebhook) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *RedeemCouponWebhook) SetContactId(v string) {
	o.ContactId = v
}

// GetCode returns the Code field value
func (o *RedeemCouponWebhook) GetCode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Code
}

// GetCodeOk returns a tuple with the Code field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetCodeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Code, true
}

// SetCode sets field value
func (o *RedeemCouponWebhook) SetCode(v string) {
	o.Code = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *RedeemCouponWebhook) GetAttributes() map[string]interface{} {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]interface{}
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetAttributesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Attributes) {
		return map[string]interface{}{}, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *RedeemCouponWebhook) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]interface{} and assigns it to the Attributes field.
func (o *RedeemCouponWebhook) SetAttributes(v map[string]interface{}) {
	o.Attributes = v
}

// GetChannelId returns the ChannelId field value
func (o *RedeemCouponWebhook) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *RedeemCouponWebhook) SetChannelId(v string) {
	o.ChannelId = v
}

// GetRedeemed returns the Redeemed field value
func (o *RedeemCouponWebhook) GetRedeemed() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Redeemed
}

// GetRedeemedOk returns a tuple with the Redeemed field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetRedeemedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Redeemed, true
}

// SetRedeemed sets field value
func (o *RedeemCouponWebhook) SetRedeemed(v bool) {
	o.Redeemed = v
}

// GetErrorMessage returns the ErrorMessage field value if set, zero value otherwise.
func (o *RedeemCouponWebhook) GetErrorMessage() string {
	if o == nil || IsNil(o.ErrorMessage) {
		var ret string
		return ret
	}
	return *o.ErrorMessage
}

// GetErrorMessageOk returns a tuple with the ErrorMessage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetErrorMessageOk() (*string, bool) {
	if o == nil || IsNil(o.ErrorMessage) {
		return nil, false
	}
	return o.ErrorMessage, true
}

// HasErrorMessage returns a boolean if a field has been set.
func (o *RedeemCouponWebhook) HasErrorMessage() bool {
	if o != nil && !IsNil(o.ErrorMessage) {
		return true
	}

	return false
}

// SetErrorMessage gets a reference to the given string and assigns it to the ErrorMessage field.
func (o *RedeemCouponWebhook) SetErrorMessage(v string) {
	o.ErrorMessage = &v
}

// GetTotalAmount returns the TotalAmount field value
func (o *RedeemCouponWebhook) GetTotalAmount() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TotalAmount
}

// GetTotalAmountOk returns a tuple with the TotalAmount field value
// and a boolean to check if the value has been set.
func (o *RedeemCouponWebhook) GetTotalAmountOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TotalAmount, true
}

// SetTotalAmount sets field value
func (o *RedeemCouponWebhook) SetTotalAmount(v string) {
	o.TotalAmount = v
}

func (o RedeemCouponWebhook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RedeemCouponWebhook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["code"] = o.Code
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["redeemed"] = o.Redeemed
	if !IsNil(o.ErrorMessage) {
		toSerialize["error_message"] = o.ErrorMessage
	}
	toSerialize["total_amount"] = o.TotalAmount
	return toSerialize, nil
}

type NullableRedeemCouponWebhook struct {
	value *RedeemCouponWebhook
	isSet bool
}

func (v NullableRedeemCouponWebhook) Get() *RedeemCouponWebhook {
	return v.value
}

func (v *NullableRedeemCouponWebhook) Set(val *RedeemCouponWebhook) {
	v.value = val
	v.isSet = true
}

func (v NullableRedeemCouponWebhook) IsSet() bool {
	return v.isSet
}

func (v *NullableRedeemCouponWebhook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRedeemCouponWebhook(val *RedeemCouponWebhook) *NullableRedeemCouponWebhook {
	return &NullableRedeemCouponWebhook{value: val, isSet: true}
}

func (v NullableRedeemCouponWebhook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRedeemCouponWebhook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


